From b8639c9fbd9a944ba72ba5482841ceeb5cee4037 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 18 May 2024 01:30:39 +0300
Subject: [PATCH 28/64] hex2t: Copy Nets from trident

See RM #639

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/hex2t.tilespec   |   1 +
 data/hex2t/tiles.png  | Bin 34967 -> 66574 bytes
 data/hex2t/tiles.spec |  22 ++++++++++------------
 3 files changed, 11 insertions(+), 12 deletions(-)

diff --git a/data/hex2t.tilespec b/data/hex2t.tilespec
index 0f79cd6952..18cfe9dc85 100644
--- a/data/hex2t.tilespec
+++ b/data/hex2t.tilespec
@@ -294,6 +294,7 @@ styles =
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
+      "tx.nets",       "Single1"
       "base.outpost",  "3Layer"
       "base.fortress", "3Layer"
       "base.airstrip", "3Layer"
diff --git a/data/hex2t/tiles.png b/data/hex2t/tiles.png
index 2fd295b0d511e2440125f09f77ccbaa45370c7d5..9d0f151482b59e0fc18308d08fb9c6593e8b8f6e 100644
GIT binary patch
diff --git a/data/hex2t/tiles.spec b/data/hex2t/tiles.spec
index 84422cd13f..3c8c470ccb 100644
--- a/data/hex2t/tiles.spec
+++ b/data/hex2t/tiles.spec
@@ -92,7 +92,7 @@ tiles = { "row", "column","tag"
   3, 3, "t.l0.jungle1"
   3, 9, "t.l1.jungle1"
 
-; more ocean in overlays
+; mMore ocean in overlays
 ;  3, 10, "t.l0.coast1"
 ;  7, 8,  "t.l0.coast2"
 ;  3, 11, "t.l0.floor1"
@@ -126,7 +126,7 @@ tiles = { "row", "column","tag"
   6, 9, "ts.horses"
 
 
-; extras
+; Extras
 
   6, 0, "tx.oil_mine"
   6, 10, "tx.oil_rig"
@@ -137,7 +137,9 @@ tiles = { "row", "column","tag"
   6, 5, "tx.fallout"
   6, 6, "tx.village"
 
-; random stuff
+  7, 10, "tx.nets"
+
+; Random stuff
 
   7, 0, "t.dither_tile"
   7, 0, "tx.darkness"
@@ -147,7 +149,7 @@ tiles = { "row", "column","tag"
   7, 4, "user.attention", "user.infratile"
   7, 5, "tx.fog"
 
-; darkness
+; Darkness
 
   8, 0, "tx.darkness_n"
   8, 1, "tx.darkness_ne"
@@ -156,11 +158,11 @@ tiles = { "row", "column","tag"
   8, 4, "tx.darkness_sw"
   8, 5, "tx.darkness_w"
 
-; goto path
+; Goto path
 
-  8, 6, "path.step"            ; turn boundary within path
-  8, 7, "path.exhausted_mp"    ; tip of path, no MP left
-  8, 8, "path.normal"          ; tip of path with MP remaining
+  8, 6, "path.step"            ; Turn boundary within path
+  8, 7, "path.exhausted_mp"    ; Tip of path, no MP left
+  8, 8, "path.normal"          ; Tip of path with MP remaining
   8, 9, "path.waypoint"
 }
 
@@ -185,8 +187,4 @@ tiles = { "row", "column","tag"
   4, 0, "upkeep.food2"
   5, 0, "upkeep.unhappy"
   6, 0, "upkeep.unhappy2"
-
 }
-
-
-
-- 
2.43.0