From aeb10973441ac8b7c0fe3d22e98c7b7c17bfe9e2 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Tue, 4 Jun 2024 03:51:29 +0300
Subject: [PATCH] Set S3_3 to alpha mode

See RM #700

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 NEWS                                       | 2 +-
 data/themes/gui-sdl2/human/theme.themespec | 4 ++--
 data/themes/gui-sdl3/human/theme.themespec | 4 ++--
 fc_version                                 | 8 ++++----
 meson.build                                | 2 +-
 server/report.c                            | 2 +-
 6 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/NEWS b/NEWS
index 5e86f57acf..252a61e05d 100644
--- a/NEWS
+++ b/NEWS
@@ -1,5 +1,5 @@
 ======================
-Welcome to Freeciv x.x
+Welcome to Freeciv 3.3
 ======================
 
 The most important changes between major releases are shown below.
diff --git a/data/themes/gui-sdl2/human/theme.themespec b/data/themes/gui-sdl2/human/theme.themespec
index 971b1bcfd1..58a5b4175e 100644
--- a/data/themes/gui-sdl2/human/theme.themespec
+++ b/data/themes/gui-sdl2/human/theme.themespec
@@ -12,8 +12,8 @@ default_font_file = "themes/gui-sdl2/human/DejaVuSans.ttf"
 default_font_size = 10
 
 ; To use CJK fonts, provide the path to the font below.
-; Fonts recommended for Freeciv can be fetched from git main branch, e.g.:
-; https://raw.githubusercontent.com/freeciv/freeciv/main/data/themes/gui-sdl2/human/fireflysung.ttf
+; Fonts recommended for Freeciv can be fetched from git S3_3 branch, e.g.:
+; https://raw.githubusercontent.com/freeciv/freeciv/S3_3/data/themes/gui-sdl2/human/fireflysung.ttf
 fonts =
   { "langname", "font_file"
     "zh_CN",    "themes/gui-sdl2/human/fireflysung.ttf"
diff --git a/data/themes/gui-sdl3/human/theme.themespec b/data/themes/gui-sdl3/human/theme.themespec
index e7595a6393..a5d1c1358d 100644
--- a/data/themes/gui-sdl3/human/theme.themespec
+++ b/data/themes/gui-sdl3/human/theme.themespec
@@ -12,8 +12,8 @@ default_font_file = "themes/gui-sdl3/human/DejaVuSans.ttf"
 default_font_size = 10
 
 ; To use CJK fonts, provide the path to the font below.
-; Fonts recommended for Freeciv can be fetched from git main branch, e.g.:
-; https://raw.githubusercontent.com/freeciv/freeciv/main/data/themes/gui-sdl3/human/fireflysung.ttf
+; Fonts recommended for Freeciv can be fetched from git S3_3 branch, e.g.:
+; https://raw.githubusercontent.com/freeciv/freeciv/S3_3/data/themes/gui-sdl3/human/fireflysung.ttf
 fonts =
   { "langname", "font_file"
     "zh_CN",    "themes/gui-sdl3/human/fireflysung.ttf"
diff --git a/fc_version b/fc_version
index e5aafed11c..3b2a5d0716 100755
--- a/fc_version
+++ b/fc_version
@@ -8,14 +8,14 @@
 MAJOR_VERSION="3"
 MINOR_VERSION="2"
 PATCH_VERSION="91"
-EMERGENCY_VERSION="8"
-VERSION_LABEL="-dev"
+EMERGENCY_VERSION="9"
+VERSION_LABEL="-alpha"
 
 # Type is either "development" or "stable"
 # Date and NEWS URL are relevant only for "stable" releases
 if test "$VERSION_LABEL" = "" ; then
   RELEASE_TYPE="stable"
-  #RELEASE_DATE="2023-05-08"
+  #RELEASE_DATE="2025-01-01"
   NEWS_URL="https://www.freeciv.org/wiki/NEWS-${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}"
 else
   RELEASE_TYPE="development"
@@ -64,7 +64,7 @@ NEXT_STABLE_VERSION="3.3.0"
 RELEASE_MONTH=0
 
 MAIN_VERSION=3.3
-DATASUBDIR=dev
+DATASUBDIR=test
 DEFAULT_FOLLOW_TAG=S3_3
 
 # Freeciv network capstring: see documentation in common/capstr.c
diff --git a/meson.build b/meson.build
index ca4a7b7cdb..cb99105c3d 100644
--- a/meson.build
+++ b/meson.build
@@ -133,7 +133,7 @@ priv_conf_data.set('SYSCONFDIR',
 
 # Release cycle phases
 # See fc_version about proper values for these.
-datasubdir = 'dev'
+datasubdir = 'test'
 priv_conf_data.set('DATASUBDIR', datasubdir)
 priv_conf_data.set('IS_DEVEL_VERSION', 1)
 priv_conf_data.set('IS_FREEZE_VERSION', 0)
diff --git a/server/report.c b/server/report.c
index 34879233e2..0bb052647d 100644
--- a/server/report.c
+++ b/server/report.c
@@ -1551,7 +1551,7 @@ void log_civ_score_now(void)
       fprintf(score_log->fp,
               "\n"
               "# For a specification of the format of this see doc/README.scorelog or \n"
-              "# <https://raw.githubusercontent.com/freeciv/freeciv/main/doc/README.scorelog>.\n"
+              "# <https://raw.githubusercontent.com/freeciv/freeciv/S3_3/doc/README.scorelog>.\n"
               "\n");
 
       fprintf(score_log->fp, "id %s\n", server.game_identifier);
-- 
2.43.0