From 7467677520f2920d45358cfb9d19ce39bf40ea94 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 9 Jun 2024 05:29:04 +0300
Subject: [PATCH 19/19] stdsounds: Add sound for tech gaining events

Sound was Public Domain (CC0) sample by StumpyStrust
https://opengameart.org/content/ui-sounds

See RM #712

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/stdsounds.soundspec    |  12 +++++++-----
 data/stdsounds/Makefile.am  |   1 +
 data/stdsounds/complete.ogg | Bin 0 -> 23804 bytes
 meson.build                 |   3 ++-
 4 files changed, 10 insertions(+), 6 deletions(-)
 create mode 100644 data/stdsounds/complete.ogg

diff --git a/data/stdsounds.soundspec b/data/stdsounds.soundspec
index bcaabb1bc2..2ac2e89907 100644
--- a/data/stdsounds.soundspec
+++ b/data/stdsounds.soundspec
@@ -9,7 +9,9 @@ artists = "\
  OpenQuartz - Frank Condello (pox@planetquake.com) [pox]\
  Warzone - Eidos Entertainment (GPL release) [warzone]\
  Eskapada - eskapada@o2.pl (Public Domain) [jt]\
- Trex0n - https://opengameart.org/users/trex0n [trex0n]"
+ Trex0n - https://opengameart.org/users/trex0n [trex0n]\
+ StumpyStrust - https://opengameart.org/users/stumpystrust [stumpy]\
+"
 
 ; For a list of tags used see README.sound, buildings.ruleset and
 ; units.ruleset.
@@ -254,7 +256,7 @@ e_bad_command = "stdsounds/illegal.ogg" ; [fcol]
 ;e_hut_gold = ""
 ;e_hut_merc = ""
 ;e_hut_settler = ""
-;e_hut_tech = ""
+e_hut_tech = "stdsounds/complete.ogg" ; [stumpy]
 ;e_hut_map = ""
 ;e_imp_auctioned = ""
 ;e_imp_auto = ""
@@ -286,10 +288,10 @@ e_log_fatal = "stdsounds/LrgExpl.ogg" ; [warzone]
 ;e_revolt_start = ""
 ;e_setting = ""
 ;e_spaceship = ""
-;e_tech_embassy = ""
-;e_tech_gain = ""
+e_tech_embassy = "stdsounds/complete.ogg" ; [stumpy]
+e_tech_gain = "stdsounds/complete.ogg" ; [stumpy]
 ;e_tech_goal = ""
-;e_tech_learned = ""
+e_tech_learned = "stdsounds/complete.ogg" ; [stumpy]
 ;e_tech_lost = ""
 ;e_treaty_alliance = ""
 ;e_treaty_broken = ""
diff --git a/data/stdsounds/Makefile.am b/data/stdsounds/Makefile.am
index 77512b587f..c1316802df 100644
--- a/data/stdsounds/Makefile.am
+++ b/data/stdsounds/Makefile.am
@@ -4,6 +4,7 @@
 pkgdatadir = $(datadir)/$(PACKAGE)/stdsounds
 
 pkgdata_DATA =          \
+	complete.ogg	\
 	fanfarehappy.ogg \
 	foot3.ogg	\
 	illegal.ogg	\
diff --git a/data/stdsounds/complete.ogg b/data/stdsounds/complete.ogg
new file mode 100644
index 0000000000000000000000000000000000000000..6ef7980ef3b14f5eef4dc649247aa563b25fb5c2
GIT binary patch
diff --git a/meson.build b/meson.build
index 028837cea7..3406d580e8 100644
--- a/meson.build
+++ b/meson.build
@@ -2895,7 +2895,8 @@ install_data('data/amplio2/activities.png',
 install_data('data/stdmusic/CullamBruce-Lockhart--Dawning_Fanfare.ogg',
              install_dir : join_paths(get_option('datadir'), 'freeciv/stdmusic'))
 
-install_data('data/stdsounds/fanfarehappy.ogg',
+install_data('data/stdsounds/complete.ogg',
+             'data/stdsounds/fanfarehappy.ogg',
              'data/stdsounds/foot3.ogg',
              'data/stdsounds/illegal.ogg',
              'data/stdsounds/inh2o.ogg',
-- 
2.43.0