From 114c6348e0da34d14034214f06366286c9f2aee1 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 9 Jun 2024 20:46:05 +0300
Subject: [PATCH 42/42] Meson: Regenerate metainfo files after fc_version
 change

See RM #705

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 meson.build | 12 ++++++++++++
 1 file changed, 12 insertions(+)

diff --git a/meson.build b/meson.build
index adf192bd12..bccd8c782c 100644
--- a/meson.build
+++ b/meson.build
@@ -1561,6 +1561,7 @@ if server_type != 'disabled'
                 command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                           '@OUTPUT@',
                           meson.project_build_root(), 'development'],
+                depend_files: files('fc_version'),
                 install: true,
                 install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -3346,6 +3347,7 @@ custom_target('mi_gtk322',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -3431,6 +3433,7 @@ custom_target('mi_gtk4',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -3515,6 +3518,7 @@ custom_target('mi_gtk4x',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -3779,6 +3783,7 @@ custom_target('mi_qt',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -3919,6 +3924,7 @@ custom_target('mi_sdl2',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4052,6 +4058,7 @@ install_data(
 #              output: '@BASENAME@',
 #              command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
 #                        '@OUTPUT@', b_root, 'development'],
+#              depend_files: files('fc_version'),
 #              install: true,
 #              install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4152,6 +4159,7 @@ custom_target('mi_mp_gtk3',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4188,6 +4196,7 @@ custom_target('mi_mp_gtk4',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4223,6 +4232,7 @@ custom_target('mi_mp_gtk4x',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4266,6 +4276,7 @@ custom_target('mi_mp_qt',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
@@ -4409,6 +4420,7 @@ custom_target('mi_ruledit',
               output: '@BASENAME@',
               command: [sh_exe, files('bootstrap/generate_metainfo.sh'),
                         '@OUTPUT@', b_root, 'development'],
+              depend_files: files('fc_version'),
               install: true,
               install_dir: join_paths(get_option('datadir'), 'metainfo'))
 
-- 
2.43.0