From 724d0d4b1149438584d9c9552a490fe02106f981 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 19 Jun 2024 00:53:50 +0300
Subject: [PATCH 13/13] game.ruleset: Improve tech_upkeep_style documentation

Do not refer to tech_upkeep_free as if it was
a game.ruleset field.

Reported by 3plus4i

See RM #727

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/game.ruleset         | 2 +-
 data/civ1/game.ruleset          | 2 +-
 data/civ2/game.ruleset          | 2 +-
 data/civ2civ3/game.ruleset      | 2 +-
 data/classic/game.ruleset       | 2 +-
 data/experimental/game.ruleset  | 2 +-
 data/granularity/game.ruleset   | 2 +-
 data/multiplayer/game.ruleset   | 2 +-
 data/sandbox/game.ruleset       | 2 +-
 data/stub/game.ruleset          | 2 +-
 data/webperimental/game.ruleset | 2 +-
 11 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/data/alien/game.ruleset b/data/alien/game.ruleset
index d89acbf75d..aad3262ca0 100644
--- a/data/alien/game.ruleset
+++ b/data/alien/game.ruleset
@@ -1339,7 +1339,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/civ1/game.ruleset b/data/civ1/game.ruleset
index 4086ed9095..6e9b39783e 100644
--- a/data/civ1/game.ruleset
+++ b/data/civ1/game.ruleset
@@ -1112,7 +1112,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/civ2/game.ruleset b/data/civ2/game.ruleset
index 0d6a950a0b..809fd75d82 100644
--- a/data/civ2/game.ruleset
+++ b/data/civ2/game.ruleset
@@ -1422,7 +1422,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/civ2civ3/game.ruleset b/data/civ2civ3/game.ruleset
index ef723574dd..f4f21a07cc 100644
--- a/data/civ2civ3/game.ruleset
+++ b/data/civ2civ3/game.ruleset
@@ -1788,7 +1788,7 @@ tech_leakage = "Embassies"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "Cities"
 
diff --git a/data/classic/game.ruleset b/data/classic/game.ruleset
index cc4b895074..c987478b43 100644
--- a/data/classic/game.ruleset
+++ b/data/classic/game.ruleset
@@ -1656,7 +1656,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/experimental/game.ruleset b/data/experimental/game.ruleset
index 9a2cb07c74..5bdc730217 100644
--- a/data/experimental/game.ruleset
+++ b/data/experimental/game.ruleset
@@ -1728,7 +1728,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "Basic"
 
diff --git a/data/granularity/game.ruleset b/data/granularity/game.ruleset
index c057689a53..b4c8450679 100644
--- a/data/granularity/game.ruleset
+++ b/data/granularity/game.ruleset
@@ -655,7 +655,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/multiplayer/game.ruleset b/data/multiplayer/game.ruleset
index 6b563088ed..70b058631c 100644
--- a/data/multiplayer/game.ruleset
+++ b/data/multiplayer/game.ruleset
@@ -1647,7 +1647,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/sandbox/game.ruleset b/data/sandbox/game.ruleset
index 0e9346f8ae..0da1c74ce9 100644
--- a/data/sandbox/game.ruleset
+++ b/data/sandbox/game.ruleset
@@ -3003,7 +3003,7 @@ tech_leakage = "Embassies"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "Cities"
 
diff --git a/data/stub/game.ruleset b/data/stub/game.ruleset
index 780e4b8eaa..5e52abec0b 100644
--- a/data/stub/game.ruleset
+++ b/data/stub/game.ruleset
@@ -515,7 +515,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
diff --git a/data/webperimental/game.ruleset b/data/webperimental/game.ruleset
index 3f743af5ff..d9153c647d 100644
--- a/data/webperimental/game.ruleset
+++ b/data/webperimental/game.ruleset
@@ -1909,7 +1909,7 @@ tech_leakage = "None"
 ; Method of paying tech upkeep
 ; "None"   - no upkeep
 ; "Basic"  - upkeep is calculated as:
-;     <Cost of technology> / tech_upkeep_divider - tech_upkeep_free
+;     <Cost of technology> / tech_upkeep_divider - <Free tech upkeep>
 ; "Cities" - upkeep is calculated like "Basic", but multiplied by number of cities
 tech_upkeep_style = "None"
 
-- 
2.43.0