From 826187bc42e385bcedc96a2f8258ac48b94c2783 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 28 Jun 2024 06:36:51 +0300
Subject: [PATCH 29/29] techs.rulesets: Correct max number of custom tech flags
 in documentation

See RM #732

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/techs.ruleset         | 2 +-
 data/civ1/techs.ruleset          | 2 +-
 data/civ2/techs.ruleset          | 2 +-
 data/civ2civ3/techs.ruleset      | 2 +-
 data/classic/techs.ruleset       | 2 +-
 data/goldkeep/techs.ruleset      | 2 +-
 data/granularity/techs.ruleset   | 2 +-
 data/multiplayer/techs.ruleset   | 2 +-
 data/ruledit/comments-3.3.txt    | 2 +-
 data/sandbox/techs.ruleset       | 2 +-
 data/stub/techs.ruleset          | 2 +-
 data/webperimental/techs.ruleset | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/data/alien/techs.ruleset b/data/alien/techs.ruleset
index e160ffcf0e..03d08ce596 100644
--- a/data/alien/techs.ruleset
+++ b/data/alien/techs.ruleset
@@ -17,7 +17,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/civ1/techs.ruleset b/data/civ1/techs.ruleset
index d71bea1cc2..79410725ad 100644
--- a/data/civ1/techs.ruleset
+++ b/data/civ1/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/civ2/techs.ruleset b/data/civ2/techs.ruleset
index 299a392873..dc19bd1d2e 100644
--- a/data/civ2/techs.ruleset
+++ b/data/civ2/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/civ2civ3/techs.ruleset b/data/civ2civ3/techs.ruleset
index 56cc119c48..0429b01808 100644
--- a/data/civ2civ3/techs.ruleset
+++ b/data/civ2civ3/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24 web-compatible"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/classic/techs.ruleset b/data/classic/techs.ruleset
index 1d1e9a5f75..b769143f31 100644
--- a/data/classic/techs.ruleset
+++ b/data/classic/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24 web-compatible"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/goldkeep/techs.ruleset b/data/goldkeep/techs.ruleset
index 5656c3a52f..1fd3e988bc 100644
--- a/data/goldkeep/techs.ruleset
+++ b/data/goldkeep/techs.ruleset
@@ -15,7 +15,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/granularity/techs.ruleset b/data/granularity/techs.ruleset
index f52d0f9897..21646ba90a 100644
--- a/data/granularity/techs.ruleset
+++ b/data/granularity/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/multiplayer/techs.ruleset b/data/multiplayer/techs.ruleset
index 5aa6012de4..546cfe85ae 100644
--- a/data/multiplayer/techs.ruleset
+++ b/data/multiplayer/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24 web-compatible"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 486075c860..8d0f91dd83 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -1326,7 +1326,7 @@ extra = "\n\
 "
 
 tech = "\
-; Names for custom tech flags. There can be up to 8 of these.\n\
+; Names for custom tech flags. There can be up to 10 of these.\n\
 ; name          = rule name; In some circumstances user may see this\n\
 ;                 as part of some sentences, so try to make it descriptive\n\
 ;                 and sensible.\n\
diff --git a/data/sandbox/techs.ruleset b/data/sandbox/techs.ruleset
index 9e759bc52d..3001a5281d 100644
--- a/data/sandbox/techs.ruleset
+++ b/data/sandbox/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/stub/techs.ruleset b/data/stub/techs.ruleset
index 6d93023143..66f61a9751 100644
--- a/data/stub/techs.ruleset
+++ b/data/stub/techs.ruleset
@@ -7,7 +7,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
diff --git a/data/webperimental/techs.ruleset b/data/webperimental/techs.ruleset
index 266c9cf373..64331c5c00 100644
--- a/data/webperimental/techs.ruleset
+++ b/data/webperimental/techs.ruleset
@@ -13,7 +13,7 @@ options = "+Freeciv-ruleset-3.3-Devel-2023.Feb.24 web-compatible"
 format_version = 40
 
 [control]
-; Names for custom tech flags. There can be up to 8 of these.
+; Names for custom tech flags. There can be up to 10 of these.
 ; name          = rule name; In some circumstances user may see this
 ;                 as part of some sentences, so try to make it descriptive
 ;                 and sensible.
-- 
2.43.0