From 131763875541b6dfdab990c9c4de5ab0879849dc Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 29 Jun 2024 11:25:34 +0300
Subject: [PATCH 10/10] alien: Replace "UnitFlag" with "UnitTypeFlag"

See RM #632

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/actions.ruleset        | 216 +++++++++++++++---------------
 data/alien/effects.ruleset        |   6 +-
 data/alien/nation_effects.ruleset |   6 +-
 data/alien/terrain.ruleset        |  74 +++++-----
 4 files changed, 151 insertions(+), 151 deletions(-)

diff --git a/data/alien/actions.ruleset b/data/alien/actions.ruleset
index 58bce8bbc6..bb848d59e9 100644
--- a/data/alien/actions.ruleset
+++ b/data/alien/actions.ruleset
@@ -387,31 +387,31 @@ quiet_actions = "Transport Disembark 2", "Enter Hut 2", "Unit Move"
 [enabler_sabotage_city]
 action        = "Sabotage City"
 actor_reqs    =
-    { "type",   "name", "range"
-      "UnitFlag", "Diplomat", "Local"
-      "DiplRel", "War", "Local"
-      "UnitState", "OnLivableTile", "Local"
-      "MinMoveFrags", "1", "Local"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Diplomat",      "Local"
+      "DiplRel",      "War",           "Local"
+      "UnitState",    "OnLivableTile", "Local"
+      "MinMoveFrags", "1",             "Local"
     }
 
 [enabler_investigate_city]
 action        = "Investigate City Spend Unit"
 actor_reqs    =
-    { "type",   "name", "range"
-      "UnitFlag", "Diplomat", "Local"
-      "UnitState", "OnLivableTile", "Local"
-      "MinMoveFrags", "1", "Local"
-      "DiplRel", "Foreign", "Local"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Diplomat",      "Local"
+      "UnitState",    "OnLivableTile", "Local"
+      "MinMoveFrags", "1",             "Local"
+      "DiplRel",      "Foreign",       "Local"
     }
 
 [enabler_steal_tech_random]
 action        = "Steal Tech"
 actor_reqs    =
-    { "type",   "name", "range"
-      "UnitFlag", "Diplomat", "Local"
-      "UnitState", "OnLivableTile", "Local"
-      "MinMoveFrags", "1", "Local"
-      "DiplRel", "Foreign", "Local"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Diplomat",      "Local"
+      "UnitState",    "OnLivableTile", "Local"
+      "MinMoveFrags", "1",             "Local"
+      "DiplRel",      "Foreign",       "Local"
     }
 target_reqs   =
     { "type",   "name", "range", "present"
@@ -421,13 +421,13 @@ target_reqs   =
 [enabler_incite_city]
 action        = "Incite City"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "Diplomat", "Local", TRUE
-      "DiplRel", "Alliance", "Local", FALSE
-      "DiplRel", "Team", "Local", FALSE
-      "UnitState", "OnLivableTile", "Local", TRUE
-      "MinMoveFrags", "1", "Local", TRUE
-      "DiplRel", "Foreign", "Local", TRUE
+    { "type",         "name",          "range", "present"
+      "UnitTypeFlag", "Diplomat",      "Local", TRUE
+      "DiplRel",      "Alliance",      "Local", FALSE
+      "DiplRel",      "Team",          "Local", FALSE
+      "UnitState",    "OnLivableTile", "Local", TRUE
+      "MinMoveFrags", "1",             "Local", TRUE
+      "DiplRel",      "Foreign",       "Local", TRUE
     }
 target_reqs   =
     { "type",   "name", "range", "present"
@@ -438,13 +438,13 @@ target_reqs   =
 [enabler_bribe_unit]
 action        = "Bribe Unit"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "Diplomat", "Local", TRUE
-      "DiplRel", "Alliance", "Local", FALSE
-      "DiplRel", "Team", "Local", FALSE
-      "UnitState", "OnLivableTile", "Local", TRUE
-      "MinMoveFrags", "1", "Local", TRUE
-      "DiplRel", "Foreign", "Local", TRUE
+    { "type",         "name",          "range", "present"
+      "UnitTypeFlag", "Diplomat",      "Local", TRUE
+      "DiplRel",      "Alliance",      "Local", FALSE
+      "DiplRel",      "Team",          "Local", FALSE
+      "UnitState",    "OnLivableTile", "Local", TRUE
+      "MinMoveFrags", "1",             "Local", TRUE
+      "DiplRel",      "Foreign",       "Local", TRUE
     }
 target_reqs   =
     { "type",   "name", "range", "present"
@@ -455,25 +455,25 @@ target_reqs   =
 [enabler_trade_route]
 action        = "Establish Trade Route"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "TradeRoute", "Local", TRUE
-      "UnitState", "HasHomeCity", "Local", TRUE
+    { "type",         "name",        "range", "present"
+      "UnitTypeFlag", "TradeRoute",  "Local", TRUE
+      "UnitState",    "HasHomeCity", "Local", TRUE
     }
 
 [enabler_marketplace]
 action        = "Enter Marketplace"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "TradeRoute", "Local", TRUE
-      "UnitState", "HasHomeCity", "Local", TRUE
+    { "type",         "name",        "range", "present"
+      "UnitTypeFlag", "TradeRoute",  "Local", TRUE
+      "UnitState",    "HasHomeCity", "Local", TRUE
     }
 
 [enabler_help_build_wonder]
 action        = "Help Wonder"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "HelpWonder", "Local", TRUE
-      "DiplRel", "Foreign", "Local", FALSE
+    { "type",         "name",       "range", "present"
+      "UnitTypeFlag", "HelpWonder", "Local", TRUE
+      "DiplRel",      "Foreign",    "Local", FALSE
     }
 target_reqs   =
     { "type",   "name", "range"
@@ -496,24 +496,24 @@ action        = "Disband Unit"
 [enabler_capture]
 action        = "Capture Units"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "Capturer", "Local", TRUE
-      "DiplRel", "War", "Local", TRUE
-      "MinMoveFrags", "1", "Local", TRUE
-      "DiplRel", "Foreign", "Local", TRUE
+    { "type",         "name",     "range", "present"
+      "UnitTypeFlag", "Capturer", "Local", TRUE
+      "DiplRel",      "War",      "Local", TRUE
+      "MinMoveFrags", "1",        "Local", TRUE
+      "DiplRel",      "Foreign",  "Local", TRUE
     }
 target_reqs   =
-    { "type",      "name",         "range", "present"
-      "UnitFlag",  "Capturable",   "Local", TRUE
-      "UnitState", "Transporting", "Local", FALSE
-      "CityTile",  "Center",       "Tile",  FALSE
+    { "type",         "name",         "range", "present"
+      "UnitTypeFlag", "Capturable",   "Local", TRUE
+      "UnitState",    "Transporting", "Local", FALSE
+      "CityTile",     "Center",       "Tile",  FALSE
     }
 
 [enabler_bombard_city]
 action        = "Bombard"
 actor_reqs    =
     { "type",         "name",        "range", "present"
-      "UnitFlag",     "Bombarder",   "Local", TRUE
+      "UnitTypeFlag", "Bombarder",   "Local", TRUE
       "UnitState",    "Transported", "Local", FALSE
       "MinMoveFrags", "1",           "Local", TRUE
       "DiplRel",      "War",         "Local", TRUE
@@ -528,7 +528,7 @@ target_reqs   =
 action        = "Bombard"
 actor_reqs    =
     { "type",         "name",        "range", "present"
-      "UnitFlag",     "Bombarder",   "Local", TRUE
+      "UnitTypeFlag", "Bombarder",   "Local", TRUE
       "UnitState",    "Transported", "Local", FALSE
       "MinMoveFrags", "1",           "Local", TRUE
       "DiplRel",      "War",         "Local", TRUE
@@ -542,10 +542,10 @@ target_reqs   =
 [enabler_build_city_pioneer]
 action        = "Found City"
 actor_reqs    =
-    { "type",   "name", "range"
-      "UnitFlag", "Cities", "Local"
-      "UnitState", "OnLivableTile", "Local"
-      "MinMoveFrags", "1", "Local"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Cities",        "Local"
+      "UnitState",    "OnLivableTile", "Local"
+      "MinMoveFrags", "1",             "Local"
     }
 target_reqs   =
     { "type",   "name", "range", "present"
@@ -556,11 +556,11 @@ target_reqs   =
 [enabler_build_city_domestic]
 action        = "Found City"
 actor_reqs    =
-    { "type",   "name", "range", "present"
-      "UnitFlag", "Cities", "Local", TRUE
-      "UnitState", "OnLivableTile", "Local", TRUE
-      "MinMoveFrags", "1", "Local", TRUE
-      "DiplRel", "Foreign", "Local", FALSE
+    { "type",         "name",          "range", "present"
+      "UnitTypeFlag", "Cities",        "Local", TRUE
+      "UnitState",    "OnLivableTile", "Local", TRUE
+      "MinMoveFrags", "1",             "Local", TRUE
+      "DiplRel",      "Foreign",       "Local", FALSE
     }
 target_reqs   =
     { "type",        "name",     "range", "present"
@@ -572,7 +572,7 @@ target_reqs   =
 action        = "Attack"
 actor_reqs    =
     { "type",          "name",         "range", "present"
-      "UnitFlag",      "NonMil",       "Local", FALSE
+      "UnitTypeFlag",  "NonMil",       "Local", FALSE
       "UnitClassFlag", "Missile",      "Local", FALSE
       "MinMoveFrags",  "1",            "Local", TRUE
       "UnitState",     "OnNativeTile", "Local", TRUE
@@ -583,7 +583,7 @@ actor_reqs    =
 action        = "Attack"
 actor_reqs    =
     { "type",          "name",    "range", "present"
-      "UnitFlag",      "NonMil",  "Local", FALSE
+      "UnitTypeFlag",  "NonMil",  "Local", FALSE
       "UnitClassFlag", "Missile", "Local", FALSE
       "MinMoveFrags",  "1",       "Local", TRUE
       "UnitClass",     "Sea",     "Local", TRUE
@@ -594,7 +594,7 @@ actor_reqs    =
 action        = "Collect Ransom"
 actor_reqs    =
     { "type",          "name",         "range", "present"
-      "UnitFlag",      "NonMil",       "Local", FALSE
+      "UnitTypeFlag",  "NonMil",       "Local", FALSE
       "UnitClassFlag", "Missile",      "Local", FALSE
       "MinMoveFrags",  "1",            "Local", TRUE
       "UnitState",     "OnNativeTile", "Local", TRUE
@@ -609,7 +609,7 @@ target_reqs   =
 action        = "Collect Ransom"
 actor_reqs    =
     { "type",          "name",         "range", "present"
-      "UnitFlag",      "NonMil",       "Local", FALSE
+      "UnitTypeFlag",  "NonMil",       "Local", FALSE
       "UnitClassFlag", "Missile",      "Local", FALSE
       "MinMoveFrags",  "1",            "Local", TRUE
       "UnitClass",     "Sea",          "Local", TRUE
@@ -624,7 +624,7 @@ target_reqs   =
 action        = "Suicide Attack"
 actor_reqs    =
     { "type",          "name",    "range", "present"
-      "UnitFlag",      "NonMil",  "Local", FALSE
+      "UnitTypeFlag",  "NonMil",  "Local", FALSE
       "UnitClassFlag", "Missile", "Local", TRUE
       "MinMoveFrags",  "1",       "Local", TRUE
       "DiplRel",       "War",     "Local", TRUE
@@ -635,7 +635,7 @@ action        = "Conquer City"
 actor_reqs    =
     { "type",           "name",          "range", "present"
       "UnitClassFlag",  "CanOccupyCity", "Local", TRUE
-      "UnitFlag",       "NonMil",        "Local", FALSE
+      "UnitTypeFlag",   "NonMil",        "Local", FALSE
       "DiplRel",        "War",           "Local", TRUE
       "MinMoveFrags",   "1",             "Local", TRUE
       "UnitState",      "OnLivableTile", "Local", TRUE
@@ -657,7 +657,7 @@ actor_reqs    =
 action        = "Paradrop Unit Enter"
 actor_reqs    =
     { "type",          "name",          "range", "present"
-      "UnitFlag",      "Paratroopers",  "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers",  "Local", TRUE
       "MinMoveFrags",  "4",             "Local", TRUE
       "UnitState",     "Transporting",  "Local", FALSE
       "Extra",         "Antigrav Base", "Tile",  TRUE
@@ -673,7 +673,7 @@ target_reqs   =
 action        = "Paradrop Unit Enter"
 actor_reqs    =
     { "type",          "name",          "range", "present"
-      "UnitFlag",      "Paratroopers",  "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers",  "Local", TRUE
       "MinMoveFrags",  "4",             "Local", TRUE
       "UnitState",     "Transporting",  "Local", FALSE
       "Extra",         "Antigrav Base", "Tile",  TRUE
@@ -687,13 +687,13 @@ target_reqs   =
 action        = "Paradrop Unit Enter Conquer"
 actor_reqs    =
     { "type",          "name",          "range", "present"
-      "UnitFlag",      "Paratroopers",  "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers",  "Local", TRUE
       "MinMoveFrags",  "4",             "Local", TRUE
       "UnitState",     "Transporting",  "Local", FALSE
       "Extra",         "Antigrav Base", "Tile",  TRUE
       "DiplRel",       "War",           "Local", TRUE
       "UnitClassFlag", "CanOccupyCity", "Local", TRUE
-      "UnitFlag",      "NonMil",        "Local", FALSE
+      "UnitTypeFlag",  "NonMil",        "Local", FALSE
     }
 target_reqs   =
     { "type",     "name",    "range", "present"
@@ -704,7 +704,7 @@ target_reqs   =
 action        = "Paradrop Unit Enter"
 actor_reqs    =
     { "type",          "name",         "range", "present"
-      "UnitFlag",      "Paratroopers", "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers", "Local", TRUE
       "MinMoveFrags",  "4",            "Local", TRUE
       "UnitState",     "Transporting", "Local", FALSE
       "CityTile",      "Center",       "Tile",  TRUE
@@ -720,7 +720,7 @@ target_reqs   =
 action        = "Paradrop Unit Enter"
 actor_reqs    =
     { "type",          "name",         "range", "present"
-      "UnitFlag",      "Paratroopers", "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers", "Local", TRUE
       "MinMoveFrags",  "4",            "Local", TRUE
       "UnitState",     "Transporting", "Local", FALSE
       "CityTile",      "Center",       "Tile",  TRUE
@@ -734,13 +734,13 @@ target_reqs   =
 action        = "Paradrop Unit Enter Conquer"
 actor_reqs    =
     { "type",          "name",          "range", "present"
-      "UnitFlag",      "Paratroopers",  "Local", TRUE
+      "UnitTypeFlag",  "Paratroopers",  "Local", TRUE
       "MinMoveFrags",  "4",             "Local", TRUE
       "UnitState",     "Transporting",  "Local", FALSE
       "CityTile",      "Center",        "Tile",  TRUE
       "DiplRel",       "War",           "Local", TRUE
       "UnitClassFlag", "CanOccupyCity", "Local", TRUE
-      "UnitFlag",      "NonMil",        "Local", FALSE
+      "UnitTypeFlag",  "NonMil",        "Local", FALSE
     }
 target_reqs   =
     { "type",     "name",    "range", "present"
@@ -767,15 +767,15 @@ actor_reqs    =
 [enabler_cultivate]
 action        = "Cultivate"
 actor_reqs    =
-    { "type",          "name",         "range", "present"
-      "UnitFlag",      "Workers",      "Local", TRUE
+    { "type",         "name",    "range", "present"
+      "UnitTypeFlag", "Workers", "Local", TRUE
     }
 
 [enabler_plant]
 action        = "Plant"
 actor_reqs    =
-    { "type",          "name",         "range", "present"
-      "UnitFlag",      "Workers",      "Local", TRUE
+    { "type",         "name",    "range", "present"
+      "UnitTypeFlag", "Workers", "Local", TRUE
     }
 
 [enabler_pillage]
@@ -788,8 +788,8 @@ actor_reqs    =
 [enabler_clean]
 action        = "Clean"
 actor_reqs    =
-    { "type",          "name",         "range", "present"
-      "UnitFlag",      "Workers",      "Local", TRUE
+    { "type",         "name",    "range", "present"
+      "UnitTypeFlag", "Workers", "Local", TRUE
     }
 
 [enabler_fortify_terrain]
@@ -797,7 +797,7 @@ action        = "Fortify"
 actor_reqs    =
     { "type",          "name",         "range", "present"
       "UnitClassFlag", "CanFortify",   "Local", TRUE
-      "UnitFlag",      "Cant_Fortify", "Local", FALSE
+      "UnitTypeFlag",  "Cant_Fortify", "Local", FALSE
       "TerrainFlag",   "NoFortify",    "Tile",  FALSE
       "Activity",      "Fortified",    "Local", FALSE
     }
@@ -807,7 +807,7 @@ action        = "Fortify"
 actor_reqs    =
     { "type",          "name",         "range", "present"
       "UnitClassFlag", "CanFortify",   "Local", TRUE
-      "UnitFlag",      "Cant_Fortify", "Local", FALSE
+      "UnitTypeFlag",  "Cant_Fortify", "Local", FALSE
       "CityTile",      "Center",       "Tile",  TRUE
       "Activity",      "Fortified",    "Local", FALSE
     }
@@ -815,8 +815,8 @@ actor_reqs    =
 [enabler_road]
 action        = "Build Road"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
+    { "type",         "name",    "range"
+      "UnitTypeFlag", "Workers", "Local"
     }
 target_reqs   =
     { "type",         "name",    "range"
@@ -826,8 +826,8 @@ target_reqs   =
 [enabler_base]
 action        = "Build Base"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
+    { "type",         "name",    "range"
+      "UnitTypeFlag", "Workers", "Local"
     }
 target_reqs   =
     { "type",         "name",    "range"
@@ -837,8 +837,8 @@ target_reqs   =
 [enabler_mining]
 action        = "Build Mine"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
+    { "type",         "name",    "range"
+      "UnitTypeFlag", "Workers", "Local"
     }
 target_reqs   =
     { "type",         "name",            "range", "present"
@@ -849,9 +849,9 @@ target_reqs   =
 [enabler_mine_mountains]
 action        = "Build Mine"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
-      "Tech",          "Burrowing",    "Player"
+    { "type",         "name",      "range"
+      "UnitTypeFlag", "Workers",   "Local"
+      "Tech",         "Burrowing", "Player"
     }
 target_reqs   =
     { "type",    "name",            "range"
@@ -862,7 +862,7 @@ target_reqs   =
 action        = "Build Irrigation"
 actor_reqs    =
     { "type",         "name",          "range"
-      "UnitFlag",     "Workers",       "Local"
+      "UnitTypeFlag", "Workers",       "Local"
       "Tech",         "Manufacturing", "Player"
     }
 target_reqs   =
@@ -874,9 +874,9 @@ target_reqs   =
 [enabler_irrigate_src_green_river]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",     "name",          "range"
-      "UnitFlag", "Workers",       "Local"
-      "Tech",     "Manufacturing", "Player"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Workers",       "Local"
+      "Tech",         "Manufacturing", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
@@ -887,9 +887,9 @@ target_reqs   =
 [enabler_irrigate_src_brown_river]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",     "name",          "range"
-      "UnitFlag", "Workers",       "Local"
-      "Tech",     "Manufacturing", "Player"
+    { "type",         "name",          "range"
+      "UnitTypeFlag", "Workers",       "Local"
+      "Tech",         "Manufacturing", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
@@ -900,9 +900,9 @@ target_reqs   =
 [enabler_irrigate_src_green_river_adjacent]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
-      "Tech",          "Water Flow",   "Player"
+    { "type",         "name",       "range"
+      "UnitTypeFlag", "Workers",    "Local"
+      "Tech",         "Water Flow", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
@@ -913,9 +913,9 @@ target_reqs   =
 [enabler_irrigate_src_brown_river_adjacent]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",          "name",         "range"
-      "UnitFlag",      "Workers",      "Local"
-      "Tech",          "Water Flow",   "Player"
+    { "type",         "name",       "range"
+      "UnitTypeFlag", "Workers",    "Local"
+      "Tech",         "Water Flow", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
@@ -926,9 +926,9 @@ target_reqs   =
 [enabler_irrigate_src_citycenter]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",     "name",       "range"
-      "UnitFlag", "Workers",    "Local"
-      "Tech",     "Water Flow", "Player"
+    { "type",         "name",       "range"
+      "UnitTypeFlag", "Workers",    "Local"
+      "Tech",         "Water Flow", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
@@ -939,9 +939,9 @@ target_reqs   =
 [enabler_irrigate_src_deep_pumping]
 action        = "Build Irrigation"
 actor_reqs    =
-    { "type",     "name",         "range"
-      "UnitFlag", "Workers",      "Local"
-      "Tech",     "Deep Pumping", "Player"
+    { "type",         "name",         "range"
+      "UnitTypeFlag", "Workers",      "Local"
+      "Tech",         "Deep Pumping", "Player"
     }
 target_reqs   =
     { "type",         "name",        "range"
diff --git a/data/alien/effects.ruleset b/data/alien/effects.ruleset
index 753b467dca..19ea392aaa 100644
--- a/data/alien/effects.ruleset
+++ b/data/alien/effects.ruleset
@@ -964,8 +964,8 @@ reqs    =
 type	= "Unit_Bribe_Cost_Pct"
 value	= -50
 reqs	=
-    { "type", "name", "range"
-      "UnitFlag", "Cities", "Local"
+    { "type",         "name",   "range"
+      "UnitTypeFlag", "Cities", "Local"
     }
 
 [effect_illegal_action_move_cost_base]
@@ -1107,7 +1107,7 @@ reqs    =
       "CityTile",      "Center",       "Tile", TRUE
       "Activity",      "Fortified",    "Local", FALSE
       "UnitClassFlag", "CanFortify",   "Local", TRUE
-      "UnitFlag",      "Cant_Fortify", "Local", FALSE
+      "UnitTypeFlag",  "Cant_Fortify", "Local", FALSE
     }
 
 [effect_city_min_hp]
diff --git a/data/alien/nation_effects.ruleset b/data/alien/nation_effects.ruleset
index 108b367cbd..24954dc3f9 100644
--- a/data/alien/nation_effects.ruleset
+++ b/data/alien/nation_effects.ruleset
@@ -74,9 +74,9 @@ reqs    =
 type    = "Veteran_Build"
 value   = 1
 reqs	=
-    { "type",       "name",      "range"
-      "Nation", "Secret Society", "Player"
-      "UnitFlag", "Diplomat", "Local"
+    { "type",         "name",           "range"
+      "Nation",       "Secret Society", "Player"
+      "UnitTypeFlag", "Diplomat",       "Local"
     }
 
 [effect_secret_society_trade]
diff --git a/data/alien/terrain.ruleset b/data/alien/terrain.ruleset
index 87eda9b586..913d7625aa 100644
--- a/data/alien/terrain.ruleset
+++ b/data/alien/terrain.ruleset
@@ -986,11 +986,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range", "present", "quiet"
-      "Tech", "Strong Force", "Player", TRUE, FALSE
-      "TerrainClass", "Land", "Tile", TRUE, FALSE
-      "UnitFlag", "Workers", "Local", TRUE, FALSE
-      "CityTile", "Center", "Tile", FALSE, TRUE
+    { "type",         "name",         "range",  "present", "quiet"
+      "Tech",         "Strong Force", "Player", TRUE,      FALSE
+      "TerrainClass", "Land",         "Tile",   TRUE,      FALSE
+      "UnitTypeFlag", "Workers",      "Local",  TRUE,      FALSE
+      "CityTile",     "Center",       "Tile",   FALSE,     TRUE
     }
 build_time     = 3
 removal_time   = 0
@@ -1014,11 +1014,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range", "present", "quiet"
-      "Tech", "Force Channeling", "Player", TRUE, FALSE
-      "TerrainClass", "Land", "Tile", TRUE, FALSE
-      "UnitFlag", "Workers", "Local", TRUE, FALSE
-      "CityTile", "Center", "Tile", FALSE, TRUE
+    { "type",         "name",             "range",  "present", "quiet"
+      "Tech",         "Force Channeling", "Player", TRUE,      FALSE
+      "TerrainClass", "Land",             "Tile",   TRUE,      FALSE
+      "UnitTypeFlag", "Workers",          "Local",  TRUE,      FALSE
+      "CityTile",     "Center",           "Tile",   FALSE,     TRUE
     }
 build_time     = 3
 removal_time   = 0
@@ -1041,11 +1041,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range", "present", "quiet"
-      "Tech", "Commercial Antigravity", "Player", TRUE, FALSE
-      "TerrainClass", "Land", "Tile", TRUE, FALSE
-      "UnitFlag", "Workers", "Local", TRUE, FALSE
-      "CityTile", "Center", "Tile", FALSE, TRUE
+    { "type",         "name",                   "range",  "present", "quiet"
+      "Tech",         "Commercial Antigravity", "Player", TRUE,      FALSE
+      "TerrainClass", "Land",                   "Tile",   TRUE,      FALSE
+      "UnitTypeFlag", "Workers",                "Local",  TRUE,      FALSE
+      "CityTile",     "Center",                 "Tile",   FALSE,     TRUE
     }
 build_time     = 3
 removal_time   = 0
@@ -1069,9 +1069,9 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range"
-      "UnitFlag", "Workers", "Local"
-      "TerrainClass", "Land", "Tile"
+    { "type",         "name",    "range"
+      "UnitTypeFlag", "Workers", "Local"
+      "TerrainClass", "Land",    "Tile"
     }
 build_time     = 0
 removal_time   = 0
@@ -1098,11 +1098,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range"
-      "Tech", "Brute Force", "Player"
-      "Extra", "Road", "Tile"
-      "UnitFlag", "Workers", "Local"
-      "TerrainClass", "Land", "Tile"
+    { "type",         "name",        "range"
+      "Tech",         "Brute Force", "Player"
+      "Extra",        "Road",        "Tile"
+      "UnitTypeFlag", "Workers",     "Local"
+      "TerrainClass", "Land",        "Tile"
     }
 build_time     = 3
 removal_time   = 0
@@ -1127,11 +1127,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range"
-      "Tech", "Maglev", "Player"
-      "Extra", "Highway", "Tile"
-      "UnitFlag", "Workers", "Local"
-      "TerrainClass", "Land", "Tile"
+    { "type",         "name",    "range"
+      "Tech",         "Maglev",  "Player"
+      "Extra",        "Highway", "Tile"
+      "UnitTypeFlag", "Workers", "Local"
+      "TerrainClass", "Land",    "Tile"
     }
 build_time     = 3
 removal_time   = 0
@@ -1159,11 +1159,11 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range"
-      "Tech", "Strong Resistance", "Player"
-      "UnitFlag", "Workers", "Local"
-      "TerrainFlag", "Radiating", "Tile"
-      "TerrainClass", "Land", "Tile" ; Needed explicitly for automatic move type assignment
+    { "type",         "name",              "range"
+      "Tech",         "Strong Resistance", "Player"
+      "UnitTypeFlag", "Workers",           "Local"
+      "TerrainFlag",  "Radiating",         "Tile"
+      "TerrainClass", "Land",              "Tile" ; Needed explicitly for automatic move type assignment
     }
 build_time     = 3
 removal_time   = 0
@@ -1190,10 +1190,10 @@ rmact_gfx      = "None"
 rmact_gfx_alt  = "-"
 rmact_gfx_alt2 = "-"
 reqs           =
-    { "type", "name", "range"
-      "Tech", "Burrowing", "Player"
-      "UnitFlag", "Workers", "Local"
-      "TerrainClass", "Oceanic", "Tile"
+    { "type",         "name",      "range"
+      "Tech",         "Burrowing", "Player"
+      "UnitTypeFlag", "Workers",   "Local"
+      "TerrainClass", "Oceanic",   "Tile"
     }
 build_time     = 3
 removal_time   = 0
-- 
2.43.0